# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from power_msgs/BatteryState.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy

class BatteryState(genpy.Message):
  _md5sum = "c7430ea7e5c95a5cba20f69647789404"
  _type = "power_msgs/BatteryState"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Name of the battery
string name

# Charge level of battery as percentage of maximum charge
float32 charge_level

# If true, the battery is being charged
bool is_charging

# When charging, this is the remaining time until fully charged.
# When discharging, this is the time until battery is empty.
# Non-zero values are considered valid.
duration remaining_time

# Total capacity of battery
float32 total_capacity

# Current capacity of battery
float32 current_capacity

# Voltage of battery
float32 battery_voltage

# Voltage of the supply breaker
float32 supply_voltage

# Voltage of the charger
float32 charger_voltage

# If true, robot is connected to the charger but not necessarily charging
bool is_charger_detected
"""
  __slots__ = ['name','charge_level','is_charging','remaining_time','total_capacity','current_capacity','battery_voltage','supply_voltage','charger_voltage','is_charger_detected']
  _slot_types = ['string','float32','bool','duration','float32','float32','float32','float32','float32','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       name,charge_level,is_charging,remaining_time,total_capacity,current_capacity,battery_voltage,supply_voltage,charger_voltage,is_charger_detected

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(BatteryState, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.name is None:
        self.name = ''
      if self.charge_level is None:
        self.charge_level = 0.
      if self.is_charging is None:
        self.is_charging = False
      if self.remaining_time is None:
        self.remaining_time = genpy.Duration()
      if self.total_capacity is None:
        self.total_capacity = 0.
      if self.current_capacity is None:
        self.current_capacity = 0.
      if self.battery_voltage is None:
        self.battery_voltage = 0.
      if self.supply_voltage is None:
        self.supply_voltage = 0.
      if self.charger_voltage is None:
        self.charger_voltage = 0.
      if self.is_charger_detected is None:
        self.is_charger_detected = False
    else:
      self.name = ''
      self.charge_level = 0.
      self.is_charging = False
      self.remaining_time = genpy.Duration()
      self.total_capacity = 0.
      self.current_capacity = 0.
      self.battery_voltage = 0.
      self.supply_voltage = 0.
      self.charger_voltage = 0.
      self.is_charger_detected = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_fB2i5fB().pack(_x.charge_level, _x.is_charging, _x.remaining_time.secs, _x.remaining_time.nsecs, _x.total_capacity, _x.current_capacity, _x.battery_voltage, _x.supply_voltage, _x.charger_voltage, _x.is_charger_detected))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.remaining_time is None:
        self.remaining_time = genpy.Duration()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.name = str[start:end]
      _x = self
      start = end
      end += 34
      (_x.charge_level, _x.is_charging, _x.remaining_time.secs, _x.remaining_time.nsecs, _x.total_capacity, _x.current_capacity, _x.battery_voltage, _x.supply_voltage, _x.charger_voltage, _x.is_charger_detected,) = _get_struct_fB2i5fB().unpack(str[start:end])
      self.is_charging = bool(self.is_charging)
      self.is_charger_detected = bool(self.is_charger_detected)
      self.remaining_time.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_fB2i5fB().pack(_x.charge_level, _x.is_charging, _x.remaining_time.secs, _x.remaining_time.nsecs, _x.total_capacity, _x.current_capacity, _x.battery_voltage, _x.supply_voltage, _x.charger_voltage, _x.is_charger_detected))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.remaining_time is None:
        self.remaining_time = genpy.Duration()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.name = str[start:end]
      _x = self
      start = end
      end += 34
      (_x.charge_level, _x.is_charging, _x.remaining_time.secs, _x.remaining_time.nsecs, _x.total_capacity, _x.current_capacity, _x.battery_voltage, _x.supply_voltage, _x.charger_voltage, _x.is_charger_detected,) = _get_struct_fB2i5fB().unpack(str[start:end])
      self.is_charging = bool(self.is_charging)
      self.is_charger_detected = bool(self.is_charger_detected)
      self.remaining_time.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_fB2i5fB = None
def _get_struct_fB2i5fB():
    global _struct_fB2i5fB
    if _struct_fB2i5fB is None:
        _struct_fB2i5fB = struct.Struct("<fB2i5fB")
    return _struct_fB2i5fB
